include "VVram.inc"
include "Chars.inc"

ext pStage_, StageMap_, topRow_, yMod_
ext VVram_

ext @Temp@byte, @Temp@byte2, @Temp@byte3, @Temp@byte4, @Temp@byte5, @Temp@byte6
ext @Temp@Word, @Temp@Word2, @Temp@Word3, @Temp@Word4, @Temp@Word5

VisibleFloorCount equ (WindowHeight+FloorHeight-1)/FloorHeight+1
WindowHeight equ VVramHeight
FloorHeight equ 4
ColumnCount equ 16
MapWidth equ ColumnCount/4

CellType_Space equ 0
CellType_Ladder equ 1
CellType_Wall equ 2
CellType_Hole equ 3

; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param1: public VVramPtr_@Param1
VVramPtr_.y_:	defs 1
cseg
VVramPtr_: public	VVramPtr_
	psha
	pshb
        ldab	VVramPtr_.y_
        aslb | aslb | aslb  ;*8
        stab <@Temp@Word+1 | clr @Temp@Word
        asl @Temp@Word+1 | rol @Temp@Word ;16
        asl @Temp@Word+1 | rol @Temp@Word ;32
        adda <@Temp@Word+1 | staa <@Temp@Word+1
        ldaa <@Temp@Word | adca #0 | staa <@Temp@Word
        ldaa <@Temp@Word+1 | adda #low VVram_ | staa <@Temp@Word+1
        ldaa <@Temp@Word | adca #high VVram_ | staa <@Temp@Word
        ldx <@Temp@Word
	pulb
	pula
rts


; MapToBackGround();
height equ @Temp@Byte
row equ @Temp@Byte2
ypos equ @Temp@Byte3
fcount equ @Temp@Byte4
byteCount equ @Temp@byte5
bitCount equ @Temp@byte6
pMap equ @Temp@Word
pair equ @Temp@Word2
pVVram equ @Temp@Word3

zseg
bits:
    defb 0
lower:
    defb 0

cseg
Repeat:
    psha
        do
            ldx <pVVram
            ldaa <ypos
            cmpa #VVramHeight
            if cs
                ldaa <pair | staa 0,x
                ldaa <pair+1 | staa 1,x
            endif
            ldaa <pVVram+1 | adda #VVramWidth | staa<pVVram+1
            ldaa <pVVram | adca #0 | staa<pVVram
            inc <ypos
            decb
        while ne | wend
    pula
rts

MapToBackGround_: public MapToBackGround_
    psha | pshb
        ldx pStage_
        ldaa 0,x
        staa <height

        ldaa topRow_ | staa <row
        if pl
            asla ;*2
            asla ;*4
            adda #low StageMap_
            staa <pMap+1
            ldaa #high StageMap_
            adca #0
            staa <pMap
        else
            ldx #StageMap_-4
            stx <pMap
        endif

        ldaa yMod_
        if ne
            nega
        endif
        staa <ypos
        ldx #VVram_
        stx <pVVram
        do
            tsta
        while mi
            ldab <pVVram+1 | subb #VVramWidth | stab <pVVram+1
            ldab <pVVram | sbcb #0 | stab <pVVram
            inca
        wend
        ldaa #VisibleFloorCount | staa <fcount
        do
            ldaa #MapWidth | staa <byteCount
            do
                ldx <pMap
                ldab <row
                if pl
                    ldaa 0,x
                    incb
                    cmpb <height
                    if cs
                        ldab MapWidth,x
                    else
                        clrb
                    endif
                else
                    clra
                    ldab MapWidth,x
                endif
                staa <bits
                stab <lower
                inx
                stx <pMap

                ldaa #4 | staa <bitCount
                do
                    ldaa <bits
                    anda #3
                    if eq
                        ldx #((Char_Space shl 8) or Char_Space)
                        stx <pair
                        ldab #1
                        bsr Repeat

                        ldaa <lower
                        anda #3
                        cmpa #CellType_Ladder
                        if eq
                            ldx #((Char_Ladder_Left shl 8) or Char_Ladder_Right)
                            stx <pair
                            ldab #3
                            bsr Repeat
                        else
                            ldab #2
                            bsr Repeat

                            cmpa #CellType_Wall
                            if eq
                                ldx #((Char_Wall shl 8) or Char_Floor)
                            else
                                ldx #((Char_Floor shl 8) or Char_Floor)
                            endif
                            stx <pair
                            ldab #1
                            bsr Repeat
                        endif
                    else
                        cmpa #CellType_Ladder
                        if eq
                            ldx #((Char_Ladder_Left shl 8) or Char_Ladder_Right)
                            stx <pair
                            ldab #3
                            bsr Repeat

                            ldaa <lower
                            anda #3
                            cmpa #CellType_Ladder
                            if eq
                                ldx #((Char_Ladder_Left shl 8) or Char_Ladder_Right)
                            else
                                cmpa #CellType_Wall
                                if eq
                                    ldx #((Char_Wall shl 8) or Char_Floor)
                                else
                                    ldx #((Char_Floor shl 8) or Char_Floor)
                                endif
                            endif
                            stx <pair
                            ldab #1
                            bsr Repeat
                        else
                            cmpa #CellType_Wall
                            if eq
                                ldx #((Char_Wall shl 8) or Char_Space)
                                stx <pair
                                ldab #3
                                bsr Repeat
                                
                                ldaa <lower
                                anda #3
                                cmpa #CellType_Wall
                                if eq
                                    ldx #((Char_Wall shl 8) or Char_Floor)
                                else
                                    ldx #((Char_Floor shl 8) or Char_Floor)
                                endif
                                stx <pair
                                ldab #1
                                bsr Repeat
                            else
                                ldx #((Char_Space shl 8) or Char_Space)
                                stx <pair
                                ldab #4
                                bsr Repeat
                            endif
                        endif
                    endif
                    ldaa <pVVram+1 | adda #low (-VVramWidth*4+2) | staa <pVVram+1
                    ldaa <pVVram | adca #high (-VVramWidth*4+2) | staa <pVVram
                    lsr <bits | lsr <bits
                    lsr <lower | lsr <lower
                    ldaa <ypos
                    suba #FloorHeight
                    staa <ypos
                    dec <bitCount
                while ne | wend
                dec <byteCount
            while ne | wend
            ldaa <pVVram+1 | adda #low (VVramWidth*(4-1)) | staa <pVVram+1
            ldaa <pVVram | adca #high (VVramWidth*(4-1)) | staa <pVVram
            inc <row
            ldaa <ypos
            adda #FloorHeight
            staa <ypos
            dec <fcount
        while ne | wend
    pulb | pula
rts